/*
    filename:   im_proc.h
    Synopsis:   functions prototypes for process module
    Date:       March the 19th 1991
 
COPYRIGHT (c) 1991  Matrox Electronic Systems Ltd.
All Rights Reserved

*/

#ifndef __I_IM_PROC_H__
#define __I_IM_PROC_H__

/* Need imseries.h for I_UNIX defines */
#ifndef __I_IMSERIES_H__
#include "imseries.h"
#endif /* __I_IMSERIES_H__ */

/* Need i_dll.h for FTYPE */
#ifndef __I_I_DLL_H__
#ifdef I_UNIX
#include <im_series/i_dll.h>
#else
#include "i_dll.h"
#endif /* I_UNIX */
#endif /* __I_I_DLL_H__ */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

void FTYPE utcclutstat(long p0,long p1,void _I_PTYPE *p2);
void FTYPE fbcmccitt3(unsigned short p0,unsigned short p1);
void FTYPE ftstobject(unsigned short p0,unsigned short p1);
void FTYPE ftstconfig(unsigned long p0,unsigned short p1,unsigned short p2,
                      unsigned short p3);
void FTYPE cocvto555(short p0,short p1,short p2,short p3);
void FTYPE cocvtogrey(short p0,short p1,short p2,short p3,short p4,short p5,
                      long p6,short p7,short p8);
void FTYPE cododistance(short p0,short p1,short p2,short p3,short p4,long p5,
                        short p6,short p7,short p8);
void FTYPE codohsigrab(short p0,short p1,short p2,short p3,short p4,short p5,
                       long p6);
void FTYPE fbdcccitt3(unsigned short p0,unsigned short p1);
void FTYPE lsdcldvideo(unsigned long _I_PTYPE *p0);
void FTYPE lsdcstcolkey(unsigned short p0, unsigned short p1,
                        unsigned short p2);
void FTYPE lsdcstdmode(unsigned long p0);
void FTYPE lsdcstrgb555(unsigned long p0);
void FTYPE lsdcstrgb888(unsigned long p0,unsigned long p1,unsigned long p2);
void FTYPE lsdcstopal(unsigned short p0);
void FTYPE lsdcstomask(unsigned short p0,unsigned short p1,unsigned short p2,
                       unsigned short p3);
void FTYPE lsdcstfbmplane(unsigned short p0);
void FTYPE lsdcstovrsource(unsigned long p0);
void FTYPE lsdcstmsbsource(unsigned long p0);
void FTYPE lsdcstpzscroll(unsigned short p0,unsigned long p1,unsigned long p2,
                          unsigned short p3,unsigned short p4,
                          unsigned short p5);
void FTYPE lsdcstwactive(unsigned short p0,unsigned short p1,
                         unsigned short p2,unsigned short p3);
void FTYPE lsdcstbgcolor(unsigned short p0,unsigned short p1,
                         unsigned short p2);
void FTYPE lsdcstbdcolor(unsigned short p0,unsigned short p1,
                         unsigned short p2);
void FTYPE lsdcinitvdo(void );
void FTYPE lsdcstbdmode(long p0);
void FTYPE lsdcstaosource(long p0);
void FTYPE lsdcstportrait(long p0);
void FTYPE lsdcstvgamode(unsigned short p0);
void FTYPE lsdcstunderlay(long p0);
void FTYPE lsdcstcropping(long p0);
void FTYPE lsdcstcropsource(long p0);
void FTYPE lsdcstrdmask(short p0,short p1,short p2,short p3,short p4,
                        short p5);
void FTYPE lsdcstsyncgun(short p0,short p1,short p2);
void FTYPE lsdcstviewprg(unsigned long p0);
void FTYPE lsdcstviewmode(long p0);
void FTYPE lsdcstviewcpy(unsigned long p0,unsigned long p1);
void FTYPE lsdcstviewseq(long p0,long p1,long p2);
void FTYPE lsdcstinterlut(unsigned long p0,unsigned long p1,unsigned long p2);
void FTYPE lsdcstalpha(unsigned long p0);
void FTYPE lsdcstosync(unsigned short p0, unsigned short p1,
                        unsigned short p2);
void FTYPE nbdfker(short p0,short p1,long p2,short p3,unsigned short p4,
                   short p5,short p6,unsigned short _I_PTYPE *p7);
void FTYPE nbdfmker(short p0,short p1,short p2,short _I_PTYPE *p3);
void FTYPE modfmstruct(short p0,short p1,short _I_PTYPE *p2);
void FTYPE modfstruct(short p0,short p1,short p2,short p3,short _I_PTYPE *p4);
void FTYPE didograb(unsigned short p0,unsigned short p1);
void FTYPE dildlogcam(unsigned short p0,long _I_PTYPE *p1);
void FTYPE didomgrab(unsigned short p0,unsigned short p1,unsigned short p2,
                     unsigned short p3,unsigned short p4,unsigned short p5,
                     unsigned short p6);
void FTYPE dislboard(unsigned long p0,unsigned long p1);
void FTYPE dislchannel(unsigned long p0);
void FTYPE dislgain(unsigned long p0);
void FTYPE dislpalette(unsigned long p0);
void FTYPE disngrab(void );
void FTYPE distdecbright(unsigned long p0);
void FTYPE distcolorfmt(unsigned long p0,double p1,double p2,double p3);
void FTYPE distcolorspace(long p0, long p1, long p2, long p3,
                          unsigned short _I_PTYPE *p4);
void FTYPE distdeccont(unsigned long p0);
void FTYPE distdoublescan(unsigned long p0);
void FTYPE distexposure(unsigned long p0,unsigned long p1,unsigned long p2);
void FTYPE distdechue(unsigned long p0);
void FTYPE disthorparm(unsigned long p0, unsigned short p1, unsigned short p2,
                       unsigned short p3, unsigned short p4, unsigned short p5);
void FTYPE distrefblack(unsigned long p0);
void FTYPE distrefwhite(unsigned long p0);
void FTYPE distdecsatur(unsigned long p0);
void FTYPE modlstruct(short p0);
void FTYPE ptdodolutmap(unsigned short p0,unsigned short p1,unsigned short p2,
                        unsigned short p3,unsigned short p4,unsigned short p5,
                        unsigned short p6,unsigned short p7,short p8);
void FTYPE modocmap(unsigned short p0,unsigned short p1,unsigned short p2);
void FTYPE modocomplab(short p0,short p1,short p2,short p3,short p4,short p5);
void FTYPE ftfdconfig(unsigned short p0,unsigned short p1,unsigned short p2,
                      unsigned short p3);
void FTYPE nbdoconv(unsigned short p0,unsigned short p1,unsigned short p2,
                    short p3,short p4,short p5);
void FTYPE ftcccorner(unsigned short p0,unsigned short p1,unsigned short p2,
                      unsigned short p3);
void FTYPE mododistance(unsigned short p0,unsigned short p1,short p2,
                        short p3);
void FTYPE modoerodil(unsigned short p0,unsigned short p1,unsigned short p2,
                      short p3,short p4,short p5);
void FTYPE modofastthin(short p0,short p1,short p2,short p3,short p4,short p5,
                        short p6);
void FTYPE nbdoizoom(short p0,short p1);
void FTYPE modolabel(unsigned short p0,unsigned short p1,short p2,
                     unsigned short p3);
void FTYPE modomarker(unsigned short p0,short p1);
void FTYPE ftccmass(unsigned short p0,unsigned short p1,unsigned short p2,
                    unsigned short p3);
void FTYPE modomatch(unsigned short p0,unsigned short p1,unsigned short p2,
                     short p3,short p4,short p5);
void FTYPE nbdomconv(unsigned short p0,unsigned short p1,unsigned short p2,
                     short p3,short p4);
void FTYPE ftccnpixels(unsigned short p0,unsigned short p1,unsigned short p2);
void FTYPE ftccper(unsigned short p0,unsigned short p1,unsigned short p2);
void FTYPE ftfdfpoint(unsigned short p0,unsigned short p1,unsigned short p2,
                      unsigned long p3);
void FTYPE nbdorank(short p0,short p1,short p2,short p3,short p4);
void FTYPE modorcdil(unsigned short p0,unsigned short p1,unsigned short p2,
                     short p3,short p4,short p5);
void FTYPE nbdornoise(unsigned short p0,unsigned short p1,short p2);
void FTYPE ftccspixels(unsigned short p0,unsigned short p1);
void FTYPE modothickthin(unsigned short p0,unsigned short p1,
                         unsigned short p2,short p3,short p4);
void FTYPE modozone(unsigned short p0,unsigned short p1,unsigned short p2);
void FTYPE didodsatfilter(short p0,short p1,short p2,short p3,short p4,
                          short p5,short p6);
void FTYPE stccfastcen(short p0,short p1,short p2,short p3,short p4,short p5);
void FTYPE fbcpbtob(unsigned short p0,unsigned short p1,long p2,
                    unsigned long p3,short p4);
void FTYPE fbcpbtdev(unsigned short p0,unsigned short p1);
void FTYPE utgnluttran(long p0,long p1,long p2,short p3,double p4,
                       unsigned short p5,unsigned short p6);
void FTYPE mognthinlut(long p0,long p1,long p2);
void FTYPE modogreythin(short p0,short p1,short p2,short p3,short p4);
void FTYPE stgtfbstat(short _I_PTYPE *p0,short _I_PTYPE *p1,short _I_PTYPE *p2);
short FTYPE moiqstruct(short p0);
void FTYPE lslmcrllut(long p0,long p1);
void FTYPE lslmdlllut(long p0,long p1);
void FTYPE lslmcplut(long p0,long p1,long p2,long p3);
void FTYPE lslmwrlut(long p0,long p1);
void FTYPE lslmrdlut(long p0,long p1);
void FTYPE lslmslboard(unsigned long p0,unsigned long p1);
void FTYPE ptdomul16(short p0,short p1,short p2,short p3,short p4,short p5,
                     short p6,short p7);
void FTYPE pcstbinarize(unsigned short p0,unsigned short p1,unsigned short p2,
                        unsigned short p3);
void FTYPE pcstfborg(unsigned short p0);
void FTYPE pcstformat(unsigned long p0,unsigned long p1,unsigned long p2);
void FTYPE pciqsys(unsigned short option,void _I_PTYPE *retval);
void FTYPE pciqusr(unsigned short option,void _I_PTYPE *retval);
void FTYPE pcsccllist(void);
void FTYPE pcsccrlist(short p0, short p1);
void FTYPE pcscexeclist(short p0);
void FTYPE pcscrmlist(short p0);
void FTYPE pcscstcond(short p0, short p1, short p2);
void FTYPE pcscstpagoffset(short p0, short p1, short p2);
void FTYPE pcscsttag(short p0, short p1);
void FTYPE pcsllogcam(unsigned short p0);
void FTYPE pcslprocmode(unsigned short p0);
void FTYPE pcslsync(unsigned short p0);
void FTYPE pcstcond(short p0,short p1,short p2);
void FTYPE pcstdir(short p0,short p1);
void FTYPE pcstkcen(short p0,short p1);
void FTYPE pcstlattice(unsigned short p0);
void FTYPE pcstsrcmsk(unsigned short p0,unsigned short p1);
void FTYPE pcstdstmsk(unsigned long p0);
void FTYPE pcstooi(unsigned short p0,unsigned short p1,unsigned short p2,
                   unsigned short p3);
void FTYPE pcstoverscan(short p0,short p1);
void FTYPE pcstroisiz(unsigned short p0,unsigned short p1);
void FTYPE pcstroipos(unsigned short p0,unsigned short p1,unsigned short p2);
void FTYPE pcstsubsamp(unsigned short p0);
void FTYPE modorecerodil(short p0,short p1,short p2,short p3,short p4,
                         short p5);
void FTYPE modorecthin(short p0,short p1,short p2,short p3,short p4);
void FTYPE ptdoalumap(unsigned short p0, unsigned short p1, unsigned short p2,
                      unsigned short p3, unsigned short p4, short p5);
void FTYPE ptdosolutmap(unsigned short p0,unsigned short p1,unsigned short p2,
                        unsigned short p3,unsigned short p4,unsigned short p5,
                        short p6);
void FTYPE stcchist(unsigned short p0,unsigned short p1,short p2);
void FTYPE stccprof(unsigned short p0,short p1,unsigned short p2,short p3);
void FTYPE stccecount(unsigned short p0,unsigned short p1,unsigned short p2,
                      short p3,short p4,short p5);
void FTYPE stccfbstat(unsigned short p0,unsigned short p1);
void FTYPE stldlut(short p0,short p1,short p2,unsigned short p3);
void FTYPE didotfilter(short p0,short p1,short p2,short p3,short p4,short p5);
void FTYPE ptdocthresh(unsigned short p0,unsigned short p1,unsigned short p2,
                       short p3,short p4,short p5,unsigned short p6,
                       unsigned short p7);
void FTYPE utcmlut(long p0,long p1,long p2,unsigned short p3,short p4);
void FTYPE utgnglut(long p0,unsigned short p1,double p2,double p3,double p4,
                    long p5,long p6);
void FTYPE utcclutextr(long p0, long p1, long p2, long p3, long p4,
                       unsigned short p5, unsigned short p6);
void FTYPE utlmgnlut(unsigned long p0,unsigned long p1,unsigned long p2,
                     unsigned long p3);
void FTYPE ptdowlevel(unsigned short p0,unsigned short p1,unsigned short p2,
                      unsigned short p3,unsigned short p4);
void FTYPE ptdowtsum(short p0,short p1,short p2,short p3,short p4,short p5,
                     long p6,short p7);
void FTYPE gspcchist(unsigned short p0,unsigned long p1,short p2);
void FTYPE gspdoconv(unsigned short p0,unsigned short p1,unsigned short p2,
                     unsigned long p3,short p4,short p5);


#ifdef  __cplusplus
}
#endif /* __cplusplus */
#endif /* __I_IM_PROC_H__ */

